# _*_ coding: utf8 _*_
import time # В этом модуле - задержки
import smbus # В этом модуле - средства для работы с шиной i2c
import kbh # В этом модуле - функция kbhit() для работы с клавиатурой
           # в неблокирующем режиме
#-------------------------------------------------------------------------------
# Тестирование прошивки контроллера ТЭНа
#-------------------------------------------------------------------------------
# Управление контроллером ТЭНа:
# '+' - увелить уровень pdm
# '-' - уменьшить уровень pdm
# 'm' - pdm - на 100%
# '0' - pdm - в 0
# Управление контроллером контактора:
# '1' - включить контактор
# '2' - выключить контактор
#-------------------------------------------------------------------------------
bus = smbus.SMBus(1) # Создаем объект "шина i2c"
addrC = 0x12 # Адрес контроллера контактора
addrT = 0x13 # Адрес контроллера ТЭНа на шине i2c
tt = kbh.TT(500) # Создаем объект - терминал, работающий в неблокирующем режиме
                 # timeout = 500 ms
pdm = 0 # Уровень pdm (pulse density modulation, ака Брезенхем)
opdm = 0
while True:
  if tt.kbhit(): # Была нажата какая-то клавиша
    ch = tt.getch() # Получаем введенный символ
    if ch == 'q': # Выход их программы 
      bus.write_byte(addrT, 0) # Выключить ТЭН
      bus.write_byte(addrC, 0) # Выключить контактор
      break
    elif ch == '+' or ch == '=': # Увеличим уровень pdm
      pdm += 1
      if pdm > 100: pdm = 100
    elif ch == '_' or ch == '-': # Уменьшим уровень pdm
      pdm -= 1
      if pdm < 0: pdm = 0
    elif ch == '0': pdm = 0      # Минимальный уровень pdm - 0%
    elif ch == 'm': pdm = 100    # Максимальный уровень pdm - 100%
    elif ch == '1': bus.write_byte(addrC, 1) # Включим контактор
    elif ch == '2': bus.write_byte(addrC, 0) # Выключим контактор
  if opdm <> pdm: # Уровень pdm был изменен - покажем его
    bus.write_byte(addrT, pdm)   # Шлем уровень pdm контроллеру ТЭНа
    print pdm; opdm = pdm
